<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
       <el-form-item label="语言标识，如 zh-CN、en-US、ja-JP" prop="locale">
        <el-input v-model="formData.locale" placeholder="请输入语言标识，如 zh-CN、en-US、ja-JP" />
      </el-form-item>
      <el-form-item label="标签名称（多语言）" prop="tagName">
        <el-input v-model="formData.tagName" placeholder="请输入标签名称（多语言）" />
      </el-form-item>
      <el-form-item label="创建时间" prop="createdAt">
        <el-date-picker
          v-model="formData.createdAt"
          type="date"
          value-format="x"
          placeholder="选择创建时间"
        />
      </el-form-item>
      <el-form-item label="更新时间" prop="updatedAt">
        <el-date-picker
          v-model="formData.updatedAt"
          type="date"
          value-format="x"
          placeholder="选择更新时间"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { TagApi, TagI18n } from '@/api/keyboard/tag'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  tagId: undefined,
  locale: undefined,
  tagName: undefined,
  createdAt: undefined,
  updatedAt: undefined
})
const formRules = reactive({
  tagId: [{ required: true, message: '标签主表ID，对应 keyboard_tag.id不能为空', trigger: 'blur' }],
  locale: [{ required: true, message: '语言标识，如 zh-CN、en-US、ja-JP不能为空', trigger: 'blur' }],
  tagName: [{ required: true, message: '标签名称（多语言）不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number, tagId?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  formData.value.tagId = tagId  as any
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await TagApi.getTagI18n(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as TagI18n
    if (formType.value === 'create') {
      await TagApi.createTagI18n(data)
      message.success(t('common.createSuccess'))
    } else {
      await TagApi.updateTagI18n(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    tagId: undefined,
    locale: undefined,
    tagName: undefined,
    createdAt: undefined,
    updatedAt: undefined
  }
  formRef.value?.resetFields()
}
</script>